﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.98
@EndOfDesignText@
Sub Class_Globals
	Private mapAddress As Map	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	mapAddress.Initialize
	mapAddress.Put("_type","NewAddress")
	mapAddress.Put("objectVersion",0)
	mapAddress.Put("address_startDate","{CALCDATE}")	'Fuzzy date from the addressStartDate
	mapAddress.Put("address_type","HOME")
	mapAddress.Put("preferred","true")
	mapAddress.Put("usage","PERMANENT")
	mapAddress.Put("newLocation","{LOCATION}")	'Indicates values (only one) from another map
	mapAddress.Put("externalResource","{EX_RESOURCE}")	'Indicates values (only one) from another map  MUST BE LAST
	
End Sub

Public Sub loadAddress (rw() As String, Hdrs As List, mapAlias As Map)
	'RW Contains the current row from the CSV job file
	'Hdrs is the list of column headers for that file
	Dim x, idx As Int
	For x = 0 To mapAddress.Size -1
		idx = Hdrs.IndexOf(mapAddress.GetKeyAt(x))
		If idx <> -1 Then
			'Column found in job file
			Dim default As String = mapAddress.GetValueAt(x)
			If default.StartsWith("{") And default.EndsWith("}") Then
				'This is a json value
				Dim objectName As String = default.Replace("{","").Replace("}","")
				If objectName = "FUZZYDATE" Then
					Dim thisFuzzyDate As FuzzyDate
					thisFuzzyDate.Initialize
					thisFuzzyDate.set(mapAddress.GetKeyAt(x), rw, Hdrs)
					mapAddress.Put(mapAddress.GetKeyAt(x), thisFuzzyDate.toJson(mapAlias))
				End If
				If objectName = "CALCDATE" Then
					Dim thisCalcDate As CalculatedDate
					thisCalcDate.Initialize
					thisCalcDate.set(mapAddress.GetKeyAt(x), rw, Hdrs)
					mapAddress.Put(mapAddress.GetKeyAt(x), thisCalcDate.toJson(mapAlias))
				End If
			Else
				'take the value form the job file
				default = rw(idx)
				mapAddress.Put(mapAddress.GetKeyAt(x), default)
			End If			
		Else
			'Column NOT found in the job file
			If mapAddress.GetValueAt(x) = "{LOCATION}" Then
				'Next level JSON value required
				Dim thisLocation As Location
				thisLocation.Initialize
				thisLocation.loadLocation(rw, Hdrs, mapAlias)
				mapAddress.Put(mapAddress.GetKeyAt(x), thisLocation.toJson(mapAlias))
			End If
			If mapAddress.GetValueAt(x) = "{EX_RESOURCE}" Then
				'Next level JSON value required
				Dim foreignIdentity As String
				Dim idx As Int = Hdrs.IndexOf("_IdentityColumn")
				If idx <> -1 Then
					Dim foreignIdx As Int = Hdrs.IndexOf(rw(idx))
					If foreignIdx <> -1 Then
						foreignIdentity = rw(foreignIdx)
						DateTime.DateFormat = "dd-MMM-yyyy:HH:mm"
						Dim thisExternalResource As ExternalResource
						thisExternalResource.Initialize(foreignIdentity & "-" & mapAddress.Get("address_type") & "-LOCATION-" & DateTime.Date(DateTime.Now))
						thisExternalResource.loadExternalResource(rw, Hdrs)
						mapAddress.Put(mapAddress.GetKeyAt(x), thisExternalResource.toJson(mapAlias))
						thisExternalResource.dispose
					End If
				End If
			End If
		End If
	Next
End Sub

Public Sub toJson (mapAlias As Map) As String
	'Returns a json string with internal column names replaced by their API alias values
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("{")
	Dim i As Int
	For i = 0 To mapAddress.Size -1
		Dim strKey As String = mapAddress.GetKeyAt(i)
		Dim strVal As String = mapAddress.GetValueAt(i)
		If strVal <> "" Then
			If mapAlias.ContainsKey(strKey) Then
				If strVal.StartsWith("[") Or strVal.StartsWith("{") Then
					sb.Append(QUOTE).append(mapAlias.Get(strKey)).Append(QUOTE & ":").Append( strVal )
				Else If strVal = Null Then
					sb.Append(QUOTE).Append(mapAlias.Get(strKey)).Append(QUOTE & ":").Append(Null)
				Else
					sb.Append(QUOTE).Append(mapAlias.Get(strKey)).Append(QUOTE & ":").Append(QUOTE & strVal & QUOTE)
				End If
			Else
				If strVal.StartsWith("[") Or strVal.StartsWith("{") Then
					sb.Append(QUOTE).append(strKey).Append(QUOTE & ":").Append( strVal )
				Else If mapAddress.GetValueAt(i) = Null Then
					sb.Append(QUOTE).Append(strKey).Append(QUOTE & ":").Append(Null)
				Else
					sb.Append(QUOTE).Append(strKey).Append(QUOTE & ":").Append(QUOTE & strVal & QUOTE)
				End If
			End If
			If i < mapAddress.Size -1 Then sb.Append(",")
		End If
	Next
	sb.Append("}")
	Return sb.ToString
End Sub
	
	
	