﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.98
@EndOfDesignText@
Sub Class_Globals
	Private mapCalcDate As Map
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	mapCalcDate.Initialize
	mapCalcDate.Put("calculatedDate","")
	mapCalcDate.Put("fuzzyDateMask","DAY")
	mapCalcDate.Put("_type","SimpleFuzzyDate")
End Sub

Public Sub set (strColname As String, rw() As String, hdrs As List)
	'Accepts name of column in current row rw() holding the address
	'Column contents can be - blank or yyyy-MM-dd or TODAY
	Dim idx As Int = hdrs.IndexOf(strColname)
	If idx <> -1 Then
		Dim strDate As String = rw(idx)
		If strDate.Length = 10 Then
			mapCalcDate.Put("calculatedDate",strDate)
		Else
			If strDate = "TODAY" Then
				DateTime.DateFormat = "yyyy-MM-dd"
				mapCalcDate.Put("calculatedDate",DateTime.Date(DateTime.Now))
			Else
				mapCalcDate.Put("calculatedDate","")
			End If
		End If
	Else
		'Column not found - return empty date
		mapCalcDate.Put("calculatedDate","")
	End If
End Sub



Public Sub toJson (mapAlias As Map) As String
	'Returns a json string with internal column names replaced by their API alias values
	If mapCalcDate.Get("calculatedDate") = "" Then Return ""	'Empty date case
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("{")
	Dim i As Int
	For i = 0 To mapCalcDate.Size -1
		Dim strKey As String = mapCalcDate.GetKeyAt(i)
		Dim strVal As String = mapCalcDate.GetValueAt(i)
		
		If mapAlias.ContainsKey(strKey) Then
			If strVal.StartsWith("[") Or strVal.StartsWith("{") Then
				sb.Append(QUOTE).append(mapAlias.Get(strKey)).Append(QUOTE & ":").Append( strVal )
			Else If strVal = Null Then
				sb.Append(QUOTE).Append(mapAlias.Get(strKey)).Append(QUOTE & ":").Append(Null)
			Else
				sb.Append(QUOTE).Append(mapAlias.Get(strKey)).Append(QUOTE & ":").Append(QUOTE & strVal & QUOTE)
			End If
		Else
			If strVal.StartsWith("[") Or strVal.StartsWith("{") Then
				sb.Append(QUOTE).append(strKey).Append(QUOTE & ":").Append( strVal )
			Else If mapCalcDate.GetValueAt(i) = Null Then
				sb.Append(QUOTE).Append(strKey).Append(QUOTE & ":").Append(Null)
			Else
				sb.Append(QUOTE).Append(strKey).Append(QUOTE & ":").Append(QUOTE & strVal & QUOTE)
			End If
		End If
		If i < mapCalcDate.Size -1 Then sb.Append(",")
	Next
	sb.Append("}")
	Return sb.ToString
End Sub