﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.98
@EndOfDesignText@
Sub Class_Globals
	Private mapContact As Map
	Private myContactType As String
	Private myTelephoneType As String
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(contactType As String, telephoneType As String)
	'NewTelephoneContact | NewEmailContact,
	'LANDLINE | MOBILE
	'Note these appear in the job file as landline_number and mobile_number and email_address
	myContactType = contactType
	myTelephoneType = telephoneType
	mapContact.Initialize
	mapContact.Put("_type", contactType)
	mapContact.Put("objectVersion",0)
	mapContact.Put("startDate",Null)
	mapContact.Put("endDate",Null)
	mapContact.Put("contactType","HOME")
	mapContact.Put("contactUsage","PERMANENT")
	Select contactType
		Case "NewTelephoneContact"
			Select telephoneType
				Case "LANDLINE"
					mapContact.Put("telephoneType", telephoneType)
					mapContact.Put("landline_number","")
				Case "MOBILE"
					mapContact.Put("telephoneType", telephoneType)
					mapContact.Put("mobile_number","")
			End Select			
		Case "NewEmailContact"
			mapContact.Put("email_address","")
	End Select

End Sub

Public Sub loadContact (rw() As String, Hdrs As List)
	'RW Contains the current row from the CSV job file
	'Hdrs is the list of column headers for that file
	Dim x, idx As Int
	For x = 0 To mapContact.Size -1
		idx = Hdrs.IndexOf(mapContact.GetKeyAt(x))
		If idx <> -1 Then
			'Column found in job file
			mapContact.Put(mapContact.GetKeyAt(x),rw(idx))
		End If
	Next	
End Sub

Public Sub isPresent() As Boolean
	'Check the contact type and test if a number or address has been found
	If myContactType = "NewTelephoneContact" Then
		Select myTelephoneType
			Case "LANDLINE"
				If mapContact.Get("landline_number") <> "" Then Return True
			Case "MOBILE"
				If mapContact.Get("mobile_number") <> "" Then Return True
		End Select
	End If
	If myContactType = "NewEmailContact" Then
		If mapContact.Get("email_address") <> "" Then Return True
	End If
	Return False
End Sub

Public Sub toJson (mapAlias As Map) As String
	'Returns a json string with internal column names replaced by their API alias values
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("{")
	Dim i As Int
	For i = 0 To mapContact.Size -1
		Dim strVal As String = mapContact.GetValueAt(i)
		If mapAlias.ContainsKey(mapContact.GetKeyAt(i)) Then
			sb.Append(QUOTE).Append(mapAlias.Get(mapContact.GetKeyAt(i))).Append(QUOTE & ":").Append(QUOTE & strVal & QUOTE)
		Else
			If strVal.StartsWith("[") Or strVal.StartsWith("{") Then
				sb.Append(QUOTE).append(mapContact.GetKeyAt(i)).Append(QUOTE & ":").Append( strVal )
			Else If mapContact.GetValueAt(i) = Null Then
				sb.Append(QUOTE).Append(mapContact.GetKeyAt(i)).Append(QUOTE & ":").Append(Null)
			Else
				sb.Append(QUOTE).Append(mapContact.GetKeyAt(i)).Append(QUOTE & ":").Append(QUOTE & strVal & QUOTE)
			End If
		End If
		If i < mapContact.Size -1 Then sb.Append(",")
	Next
	sb.Append("}")
	Return sb.ToString
End Sub

