﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.3
@EndOfDesignText@
Sub Class_Globals
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	
End Sub

public Sub dateToEpochTime (strDate As String) As Long
	'Incoming date dormat must be yyyy-MM-dd or "TODAY"
	Dim epoch As Long
	DateTime.DateFormat = "yyyy-MM-dd"
	If strDate = "TODAY" Then
		epoch = DateTime.Now - DateTime.DateParse("1970-01-01")
	Else
		epoch = DateTime.DateParse(strDate) - DateTime.DateParse("1970-01-01")
	End If
	Return epoch
End Sub

Public Sub jsonArrayToList (strJson As String) As List
	Dim jp As JSONParser
	jp.Initialize(strJson)

	Dim myList As List
	myList.Initialize
	If strJson.StartsWith("[") Then
		Try
			myList = jp.NextArray
		Catch
			Log("jsonArrayToList failed..")
			File.WriteString(File.DirApp, "BadJson.log",strJson)
			Log(LastException)
		End Try
	End If
	Return myList
End Sub

public Sub jsonObjectToMap (strJson As String) As Map
	Dim jp As JSONParser
	jp.Initialize(strJson)

	Dim myMap As Map
	myMap.Initialize
	If strJson.StartsWith("{") Then
		Try
			myMap = jp.NextObject
		Catch
			Log("jsonObjectToMap failed ..")
			Log(LastException)
		End Try
	End If	
	Return myMap
End Sub

Public Sub shieldBadJson( str As String) As String
	Dim newStr As String = str.Replace(", ",",")
	newStr = newStr.Replace(" ","|")
	newStr = newStr.Replace("/","¬")
	newStr = newStr.Replace("\","~")
	Return newStr
End Sub

public Sub restoreBadJson(str As String) As String
	Dim newStr As String = str.Replace("|"," ")
	newStr = newStr.Replace("¬","/")
	newStr = newStr.Replace("~","\")
	Return newStr
End Sub

Public Sub deNull(str As String) As String
	If str="null" Then str = ""
	Return str
End Sub

public Sub createOutputFile(key As String, value As String)
	'Start a new CSV results file
	If File.Exists(Main.gresultsPath, Main.gresultsName) = True Then
		If File.Delete(Main.gresultsPath, Main.gresultsName) = False Then
			Log("Unable to delete previous results file")
			ExitApplication2(2)
		End If
	End If
	Dim strRow As String = QUOTE & key & QUOTE & "," & QUOTE & value & QUOTE
	Main.utils.addToOutputFile(strRow)
End Sub

public Sub addToOutputFile(strRow As String)
	Dim out As OutputStream
	strRow = strRow & CRLF
	Try
		out = File.OpenOutput(Main.gresultsPath, Main.gresultsName, True)	
	Catch
		Log("Failed to open the Results file")
		ExitApplication2(2)
	End Try
	

	Dim data() As Byte
	data = strRow.GetBytes("UTF8")
	Try
		out.WriteBytes(data, 0, data.Length)
	Catch
		Log("Failed to write to Log file")
		Log(LastException)
	End Try
	out.Close
End Sub

public Sub createFileContainingNamesOfReturnedValues (myMap As Map, callName As String)
	Dim sb As StringBuilder
	sb.Initialize
	For Each ky As String In myMap.Keys
		sb.Append(ky).Append(CRLF)
	Next
	File.WriteString(File.DirApp, "APIValues." & callName & ".list", sb.ToString)
End Sub

public Sub getMapFromMap ( inMap As Map, valueName As String ) As Map
	Dim newMap As Map
	newMap.Initialize
	Try
		newMap = inMap.Get(valueName)
	Catch
		Log("")
	End Try
	Return newMap
End Sub

public Sub getStringFromMap ( inMap As Map, valueName As String) As String
	Dim rString As String
	Try
		rString = inMap.Get(valueName)
	Catch
		Log("")
	End Try
	Return rString
End Sub

public Sub getIntFromMap ( inMap As Map, valueName As String) As Int
	Dim r As Int
	Try
		r = inMap.Get(valueName)
	Catch
		Log("")
	End Try
	Return r
End Sub

public Sub getDoubleFromMap ( inMap As Map, valueName As String ) As Double
	Dim d As Double
	Try
		d = inMap.Get(valueName)
	Catch
		Log("")
	End Try
	Return d
End Sub

public Sub getListFromMap ( inMap As Map, valueName As String ) As List
	Dim l As List
	l.Initialize
	Try
		l = inMap.Get(valueName)
	Catch
		Log("")
	End Try
	If l.IsInitialized = False Then l.Initialize
	Return l
End Sub

'DEBUG specials
Public Sub logMap ( m As Map)
	Log("Listing the map ..")
	Dim x As Int
	For x = 0 To m.Size -1
		Log(m.GetKeyAt(x) & " = " & m.GetValueAt(x))
	Next
End Sub

Public Sub logList (l As List)
	Log("Listing the List....")
	Dim x As Int
	For x = 0 To l.Size -1
		Log(l.Get(x))
	Next
End Sub