﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.98
@EndOfDesignText@
'Note This is a HTTP DELETE
'Tested OK on CIS1
Sub Class_Globals
	Private apiPath As String = "/eclipse/rest/personPersonRelationship/%relationshipId%?nominatedPersonId=%roleAPersonId%"		'Must start with "/"
	Private header() As String = Array As String("Accept","application/json")
	Private failureCount As Long


	'These are Mandatory items that must occur in the job file
	Private listMandatoryArguments As List = Array As String ( 	"roleAPersonId", "relationshipId" )
																													
	
	Private jobFilePath As String
	Private jobFileName As String
	Private listJobFileHdrs As List
	Private listJobFileRows As List
	
	Private outputFileIsCreated As Boolean = False
'	Private idx2 As Int
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize( fPath As String, fName As String)
		
	listJobFileHdrs.Initialize
	listJobFileRows.Initialize
	jobFilePath = fPath
	jobFileName = fName
	
End Sub





Public Sub Validate As returnDetails
	'This method also reads the file into the listJobFileRows and listJobFileHdrs lists ready for processing
	Dim r As returnDetails
	r.Initialize
	'Check the job file contains the necessary mandatory fields
	Try
		listJobFileRows = Main.su.LoadCSV2(jobFilePath, jobFileName, ",", listJobFileHdrs)
		Main.logResult("Job file contains " & listJobFileRows.Size & " rows of " & listJobFileHdrs.Size & " columns")
	Catch
		Log(LastException)
		r.success = False
		r.value = -100
		r.description = "Failed to load the Job file. CSV Error"
		r.fatal = True
		Return r
	End Try
	
	'Check the required columns exist
	Dim x As Int
	Dim listValidationErrors As List
	listValidationErrors.Initialize
	For x = 0 To listMandatoryArguments.Size -1
		If listJobFileHdrs.IndexOf(listMandatoryArguments.Get(x)) = -1 Then
			'Mandatory argument does not feature in the column list of the job file
			listValidationErrors.Add("ERROR - Mandatory column/argument " & listMandatoryArguments.Get(x) & " not found in job file")
		End If
	Next
	
	'Check and report errors in the above required columns check
	If listValidationErrors.Size > 0 Then
		For Each str As String In listMandatoryArguments
			Main.logResult(str)
		Next
		r.success = False
		r.value = -100
		r.description = "One or more mandatory columns/arguments missing"
		r.fatal = True
		Return r
	End If
		
	r.success = True
	r.value = 0
	r.description = "Validation passed"
	r.fatal = False
	Return r
End Sub

public Sub execute As ResumableSub
	'Process the job file - row by row
	Dim rowNum As Int
'	Dim x As Int
'	Dim idx As Int

	Dim r As returnDetails
	r.Initialize
	
	Dim rc As RestCall
	rc.Initialize

	For rowNum = 0 To listJobFileRows.Size - 1			'For each row in the job file
		Dim rw() As String = listJobFileRows.Get(rowNum)
		Dim idxRelId As Int = listJobFileHdrs.IndexOf("relationshipId")
		Dim idxRoleA As Int = listJobFileHdrs.IndexOf("roleAPersonId")

		
		Dim newApiPath As String = apiPath.Replace("%relationshipId%", rw(idxRelId))
		newApiPath = newApiPath.Replace("%roleAPersonId%", rw(idxRoleA))
		

	
		
		'API Call
		'========
		
		Wait For (rc.restDelete(newApiPath, header, rowNum)) complete
		
		Dim strAllocatedId As String
		If outputFileIsCreated = False Then
			Main.utils.createOutputFile("relationshipId","EclipseId / Error")
			outputFileIsCreated = True
		End If
		If rc.postSuccess = True Then
			Log("Relationship " & rw(idxRelId) & " deleted.")
			strAllocatedId = "Deleted"
		Else
			strAllocatedId = "ERROR - " & rc.failReason.Replace(QUOTE, "'")
			'Also need to know what errors look like and process them accordingly
			Log("Delete FAILED.")
			failureCount = failureCount + 1
		End If
		

		
		Main.utils.addToOutputFile(QUOTE & rw(idxRelId) & QUOTE & "," & QUOTE & strAllocatedId & QUOTE)
	Next		'Next row in job file
	
	Log("===========================")
	If failureCount > 0 Then
		Log("  All done - with " & failureCount & " failures.")
	Else
		Log("  All Successfully done!")
	End If
	Log("===========================")
	ExitApplication2(0)
	Return r		'Just to keep the compiler happy...
		
End Sub

