﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.98
@EndOfDesignText@
Sub Class_Globals
	Private mapExternalResource As Map
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(resourceIdentifier As String)
	mapExternalResource.Initialize
	mapExternalResource.Put("_type","NewExternalResource")
	mapExternalResource.Put("systemIdentifier","EXTRACTOR")
	mapExternalResource.Put("resourceIdentifier",resourceIdentifier)
End Sub

public Sub loadExternalResource (rw() As String, Hdrs As List)
'RW Contains the current row from the CSV job file
'Hdrs is the list of column headers for that file
	Dim x, idx As Int
	For x = 0 To mapExternalResource.Size -1
		idx = Hdrs.IndexOf(mapExternalResource.GetKeyAt(x))
		If idx <> -1 Then
			'Column found in job file
			mapExternalResource.Put(mapExternalResource.GetKeyAt(x),rw(idx))
		End If
	Next
End Sub

Public Sub toJson (mapAlias As Map) As String
	'Returns a json string with internal column names replaced by their API alias values
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("{")
	Dim i As Int
	For i = 0 To mapExternalResource.Size -1
		Dim strVal As String = mapExternalResource.GetValueAt(i)
		If mapAlias.ContainsKey(mapExternalResource.GetKeyAt(i)) Then
			sb.Append(QUOTE).Append(mapAlias.Get(mapExternalResource.GetKeyAt(i))).Append(QUOTE & ":").Append(QUOTE & strVal & QUOTE)
		Else
			If strVal.StartsWith("[") Or strVal.StartsWith("{") Then
				sb.Append(QUOTE).append(mapExternalResource.GetKeyAt(i)).Append(QUOTE & ":").Append( strVal )
			Else If mapExternalResource.GetValueAt(i) = Null Then
				sb.Append(QUOTE).Append(mapExternalResource.GetKeyAt(i)).Append(QUOTE & ":").Append(Null)
			Else
				sb.Append(QUOTE).Append(mapExternalResource.GetKeyAt(i)).Append(QUOTE & ":").Append(QUOTE & strVal & QUOTE)
			End If
		End If
		If i < mapExternalResource.Size -1 Then sb.Append(",")
	Next
	sb.Append("}")
	Return sb.ToString
End Sub

Public Sub dispose
	mapExternalResource.Clear
End Sub