﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.98
@EndOfDesignText@
Sub Class_Globals
	Private mapLocation As Map
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	mapLocation.Initialize
	mapLocation.Put("_type","NewLocation")
	mapLocation.Put("objectVersion",0)
	mapLocation.Put("primaryNameOrNumber","")
	mapLocation.Put("street","")
	mapLocation.Put("town","")
	mapLocation.Put("locality","")
	mapLocation.Put("postcode","")
	mapLocation.Put("countryCode","")
	mapLocation.Put("resolveLocation","false")
	mapLocation.Put("locality","")
'	mapLocation.Put("externalResource","{EX_RESOURCE}")	'Indicates values (only one) from another map
'	mapLocation.Put("roomDescription","")
'	mapLocation.Put("floorDescription","")
	
End Sub

Public Sub loadLocation (rw() As String, Hdrs As List, mapAlias As Map)
	'RW Contains the current row from the CSV job file
	'Hdrs is the list of column headers for that file
	Dim x, idx As Int
	For x = 0 To mapLocation.Size -1
		idx = Hdrs.IndexOf(mapLocation.GetKeyAt(x))
		If idx <> -1 Then
			'Column found in job file
			mapLocation.Put(mapLocation.GetKeyAt(x),rw(idx))
		Else			
			If mapLocation.GetValueAt(x) = "{EX_RESOURCE}" Then
				'Next level JSON value required
				Dim foreignIdentity As String
				Dim idx As Int = Hdrs.IndexOf("_IdentityColumn")
				If idx <> -1 Then
					Dim foreignIdx As Int = Hdrs.Get(idx)
					If foreignIdx <> -1 Then
						foreignIdentity = rw(foreignIdx)
						DateTime.DateFormat = "dd-MMM-yyyy:HH:mm"
						Dim thisExternalResource As ExternalResource
						thisExternalResource.Initialize(foreignIdentity & "-HOME-LOCATION-" & DateTime.Date(DateTime.Now))
						thisExternalResource.loadExternalResource(rw, Hdrs)
						mapLocation.Put(mapLocation.GetKeyAt(x), thisExternalResource.toJson(mapAlias))
						thisExternalResource.dispose
					End If
				End If
			End If
		End If
	Next
End Sub

Public Sub toJson (mapAlias As Map) As String
	'Returns a json string with internal column names replaced by their API alias values
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("{")
	Dim i As Int
	For i = 0 To mapLocation.Size -1
		Dim strKey As String = mapLocation.GetKeyAt(i)
		Dim strVal As String = mapLocation.GetValueAt(i)
		If strVal <> "" Then
			If mapAlias.ContainsKey(strKey) Then
				If strVal.StartsWith("[") Or strVal.StartsWith("{") Then
					sb.Append(QUOTE).append(mapAlias.Get(strKey)).Append(QUOTE & ":").Append( strVal )
				Else If strVal = Null Then
					sb.Append(QUOTE).Append(mapAlias.Get(strKey)).Append(QUOTE & ":").Append(Null)
				Else
					sb.Append(QUOTE).Append(mapAlias.Get(strKey)).Append(QUOTE & ":").Append(QUOTE & strVal & QUOTE)
				End If
			Else
				If strVal.StartsWith("[") Or strVal.StartsWith("{") Then
					sb.Append(QUOTE).append(strKey).Append(QUOTE & ":").Append( strVal )
				Else If mapLocation.GetValueAt(i) = Null Then
					sb.Append(QUOTE).Append(strKey).Append(QUOTE & ":").Append(Null)
				Else
					sb.Append(QUOTE).Append(strKey).Append(QUOTE & ":").Append(QUOTE & strVal & QUOTE)
				End If
			End If
			If i < mapLocation.Size -1 Then sb.Append(",")
		End If
	Next
	sb.Append("}")
	Return sb.ToString
End Sub