﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.3
@EndOfDesignText@
Sub Class_Globals	
	Public strResponse As String	'Exactly as returned by the API
	Public mapResponseHeaders As Map
	Public httpResponse As Int
	
	Private sessionCookie As String
	Public postSuccess As Boolean
	Public failReason As String
	

End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	sessionCookie = ""

End Sub

public Sub restGet(apiPath As String, header() As String, payload As String, taskId As Int) As ResumableSub
	'Call the RestAPI and mapResponse and listReturnedValues
	'Log("API call = " & apiPath & "?" & payload)
	Log("API Get Call " & taskId)
	
	Dim apiURL As String = Main.mapConfig.Get("EndPoint") & apiPath
	If payload.Length > 0 Then payload = "?" & payload
	
	Dim j As HttpJob
	j.Initialize("get", Me)	

	j.Download(apiURL & payload)
	For x = 0 To header.Length - 1 Step 2
		j.GetRequest.SetHeader(header(x), header(x+1))
	Next
	If sessionCookie = "" Then
		j.Username = Main.mapConfig.Get("AuthName")
		j.Password = Main.mapConfig.Get("AuthPassword")
	Else
		j.GetRequest.SetHeader("Cookie",sessionCookie)
	End If
	
	Wait For (j) JobDone(j As HttpJob)
	
	If j.Success Then
		mapResponseHeaders = j.Response.GetHeaders
		If mapResponseHeaders.ContainsKey("set-cookie") Then sessionCookie = mapResponseHeaders.Get("set-cookie")
		strResponse = j.GetString
		postSuccess = True
		If Main.debug Then logApiCall("GET-" & apiPath, payload, "SUCCESS")

	Else
		Log ("GET ERROR - " & j.Response.ErrorResponse)
		Main.logResult("HTTP GET Request error - " & j.Response.ErrorResponse)
		postSuccess = False
		failReason = j.Response.ErrorResponse.Replace(QUOTE, "'")
		If Main.debug Then logApiCall("GET-" & apiPath, payload, failReason)
	End If
	
	j.Release
	Return True
End Sub



Public Sub restPost (apiPath As String, header() As String, data As String, taskId As Int) As ResumableSub
	'header is a string array of key,value pairs
	
	Log("API Post Call " & taskId)
	failReason = ""
	postSuccess = True
	
	Dim apiURL As String = Main.mapConfig.Get("EndPoint") & apiPath
	'Log("Endpoint ... " & apiURL)
	'Log("Payload .... " & data)
	
	Dim j As HttpJob
	j.Initialize("", Me)
	j.PostString(apiURL, data)
	
'	j.Username = Main.mapConfig.Get("AuthName")
'	j.Password = Main.mapConfig.Get("AuthPassword")
	
	
	If sessionCookie = "" Then
		j.Username = Main.mapConfig.Get("AuthName")
		j.Password = Main.mapConfig.Get("AuthPassword")
	Else
		j.GetRequest.SetHeader("Cookie",sessionCookie)
		'Log("using cookie - " & sessionCookie)
	End If
	
	Dim x As Int
	For x = 0 To header.Length - 1 Step 2
		j.GetRequest.SetHeader(header(x), header(x+1))
	Next
	j.GetRequest.SetContentType("application/json;charset=UTF-8")
	j.GetRequest.SetContentEncoding("gzip, deflate, br")


	Wait For (j) JobDone(j As HttpJob)
	
	If j.Success Then
		mapResponseHeaders = j.Response.GetHeaders
		If mapResponseHeaders.ContainsKey("set-cookie") Then sessionCookie = mapResponseHeaders.Get("set-cookie")
		strResponse = j.GetString
		postSuccess = True
		If Main.debug Then logApiCall("POST-" & apiPath, data, "SUCCESS")

	Else
		Log ("POST ERROR - " & j.Response.ErrorResponse)
		Main.logResult("HTTP POST Request error - " & j.Response.ErrorResponse)
		For x = 0 To header.Length -1
			Main.logResult("HTTP POST Header " & x & " - " & header(x))
		Next
		Main.logResult("HTTP POST Payload - " & data)
		
		postSuccess = False
		failReason = j.Response.ErrorResponse.Replace(QUOTE, "'")
		If Main.debug Then logApiCall("POST-" & apiPath, data, failReason)

	End If
	httpResponse = j.Response.StatusCode
	j.Release
	Return True
End Sub

Public Sub restDelete (apiPath As String, header() As String, taskId As Int) As ResumableSub
	Log("API Post Call " & taskId)
	failReason = ""
	postSuccess = True
	
	Dim apiURL As String = Main.mapConfig.Get("EndPoint") & apiPath
	
	Dim j As HttpJob
	j.Initialize("", Me)
	j.Delete(apiURL)
	If sessionCookie = "" Then
		j.Username = Main.mapConfig.Get("AuthName")
		j.Password = Main.mapConfig.Get("AuthPassword")
	Else
		j.GetRequest.SetHeader("Cookie",sessionCookie)
		'Log("using cookie - " & sessionCookie)
	End If
	
	Dim x As Int
	For x = 0 To header.Length - 1 Step 2
		j.GetRequest.SetHeader(header(x), header(x+1))
	Next
'	j.GetRequest.SetContentType("Content-Type: text/plain;charset=UTF-8")
'	j.GetRequest.SetContentEncoding("gzip, deflate, br")
	
	Wait For (j) JobDone(j As HttpJob)
	
	If j.Success Then
		mapResponseHeaders = j.Response.GetHeaders
		If mapResponseHeaders.ContainsKey("set-cookie") Then sessionCookie = mapResponseHeaders.Get("set-cookie")
		strResponse = j.GetString
		postSuccess = True
		If Main.debug Then logApiCall("DELETE-" & apiPath, "HTTP Delete", "SUCCESS")

	Else
		Log ("POST ERROR - " & j.Response.ErrorResponse)
		Main.logResult("HTTP DELETE Request error - " & j.Response.ErrorResponse)
		For x = 0 To header.Length -1
			Main.logResult("HTTP DELETE Header " & x & " - " & header(x))
		Next
		
		postSuccess = False
		failReason = j.Response.ErrorResponse.Replace(QUOTE, "'")
		If Main.debug Then logApiCall("DELETE-" & apiPath, "HTTP Delete", failReason)

	End If
	httpResponse = j.Response.StatusCode
	j.Release
	Return True

End Sub

Private Sub logApiCall(path As String, payload As String, response As String)
	Dim out As OutputStream
	Dim data() As Byte

	If Main.debugFileIsPresent = False Then
		File.Delete(Main.gLogPath, "debug.csv")
	End If
	
	Try
		out = File.OpenOutput(Main.gLogPath, "debug.csv", True)
	Catch
		Log("Failed to open the Debug file")
		ExitApplication2(2)
	End Try
	
	If Main.debugFileIsPresent = False Then
		Dim headers As String = QUOTE & "Path" & QUOTE & "," & QUOTE & "Payload" & QUOTE & CRLF
		data = headers.GetBytes("UTF8")
		Try
			out.WriteBytes(data, 0, data.Length)
		Catch
			Log("Failed to write to Debug file")
			Log(LastException)
		End Try
		Main.debugFileIsPresent = True

	End If
	
	Dim strRow As String = QUOTE & path & QUOTE & "," & QUOTE & payload.Replace(QUOTE,"'") & QUOTE & CRLF
	data = strRow.GetBytes("UTF8")
	Try
		out.WriteBytes(data, 0, data.Length)
	Catch
		Log("Failed to write to Debug file")
		Log(LastException)
	End Try
	
	out.Close	
End Sub


